program ConTaken;

uses Windows, messages, Unit2, Unit3, types, graphics, sysutils;
  
{$R ConTaken.res}

var ind: integer;

function WindowProc(Wnd:HWND; Msg:Integer; wParam:wParam; lParam:lParam):Longint; stdcall;
 var i:integer;
     PS:PAINTSTRUCT;
begin
  Result:=0;
  case Msg of
   WM_COMMAND:
   if HIWORD(wParam)=BN_CLICKED then begin
    if cardinal(lparam)=but1 then BEGIN // 1
     buffer.Canvas.Brush.Color:=0;
     buffer.Canvas.FillRect(r1);
     createpole;
     setwindowtext(mainwnd,' Conjunct Taken');
     DrawFrame;
    END;

    if cardinal(lparam)=ch1 then begin
     if SendMessage(ch1, BM_GETCHECK, 0, 0)=BST_CHECKED then draw:=true else draw:=false;
    end;

    if cardinal(lparam)=but2 then BEGIN  // 2
      getwindowtext(ed1,b2cap,256); // 
      if pos('.',b2cap)<>0 then b2cap[pos('.',b2cap)-1]:=',';
      if strtofloat(b2cap)<=0 then exit;
      for i:=1 to high(pole) do begin
       pole[i].dx:=(0.5-random)/strtofloat(b2cap);
       pole[i].dy:=(0.5-random)/strtofloat(b2cap);
      end;

     getwindowtext(but2,b2cap,256);
     if b2cap='Go' then begin
      setwindowtext(mainwnd,' Conjunct Taken');
      setwindowtext(but2,'Stop');
      enablewindow(but1,false);
      enablewindow(ed1,false);
      trig:=true;         // 
     end else begin
      setwindowtext(but2,'Go');
      enablewindow(but1,true);
      enablewindow(ed1,true);
      trig:=false;
     end;
    END;
   end else Result:=DefWindowProc(Wnd, Msg, wParam, lParam);

   WM_CREATE:
   begin
    But1:=CreateWindow('BUTTON', 'Reset', WS_CHILD
     or WS_VISIBLE or BS_PUSHLIKE,10,12,75,25,Wnd,0,hInstance,nil);
    SendMessage(But1,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    But2:=CreateWindow('BUTTON','Go',WS_CHILD
     or WS_VISIBLE or BS_PUSHLIKE,10,64,75,25,Wnd,0,hInstance,nil);
    SendMessage(But2,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    ch1:=CreateWindow('BUTTON', 'Visible', WS_CHILD
     or WS_VISIBLE or BS_AUTOCHECKBOX ,10,110,75,25,Wnd,0,hInstance,nil);
    SendMessage(ch1,WM_SETFONT,hFontbold,MAKELPARAM(0,0));
    SendMessage(ch1, BM_SETCHECK, BST_CHECKED, 0);
    draw:=true;

    ed1:=CreateWindow('EDIT', '0,5', WS_CHILD or WS_BORDER	
     or WS_VISIBLE ,10,140,75,20,Wnd,0,hInstance,nil);
    SendMessage(ch1,WM_SETFONT,hFontbold,MAKELPARAM(0,0));

    SetFocus(But1);
    result:=0;
   end;

   WM_DESTROY:begin
    fin:=true;
    activ:=false;
    trig:=false;
    DeleteObject(hFontBold);
    for i:=1 to high(pole) do pole[i].pic.Free;
    unregisterclass('MyWKlass',hinstance);
    sleep(100);
    postquitmessage(0);
   end;

   WM_SIZE:if fin=false then begin
    trig:=false;
    sleep(50);
    GetClientRect(MainWND,r2);
    if r2.Right<>0 then buffer.Width:=r2.Right-r2.Left-marg;
    buffer.Height:=r2.Bottom-r2.Top;
    buffer.Canvas.Brush.Color:=15780518; //  
    buffer.Canvas.FillRect(r2);
    buffer.Canvas.Pen.Color:=clred;
    buffer.Canvas.MoveTo(r1.Left-1,0);
    buffer.Canvas.LineTo(r1.Left-1,buffer.Height);
    buffer.Canvas.MoveTo(r1.right,0);
    buffer.Canvas.LineTo(r1.right,buffer.Height);
    buffer.Canvas.MoveTo(0,r1.Top-1);
    buffer.Canvas.LineTo(buffer.Width,r1.Top-1);
    buffer.Canvas.MoveTo(0,r1.Bottom);
    buffer.Canvas.LineTo(buffer.Width,r1.Bottom);
    buffer.Canvas.Brush.Color:=0;
    bitblt(getdc(MainWND),marg,0,buffer.Width,buffer.Height,buffer.Canvas.Handle,0,0,SRCCOPY);
    postmessage(MainWND,wm_paint,0,0);
    getwindowtext(but2,b2cap,256);
    if b2cap='Stop' then trig:=true;   
    result:=0;
   end;          

 {  WM_LBUTTONDOWN:begin
    DrawTrig:=true;
    ax:=LOWORD(lParam);
    ay:=HIWORD(lParam);
    buffer.Canvas.Pen.Width:=3;
    buffer.Canvas.Pen.Color:=255;
    buffer.Canvas.MoveTo(ax-marg,ay);  //  
    buffer.Canvas.LineTo(ax-marg,ay);
    DrawFrame;
   end;

   WM_MOUSEMOVE: if DrawTrig then begin
    buffer.Canvas.MoveTo(ax-marg,ay);
    ax:=LOWORD(lParam);
    ay:=HIWORD(lParam);
    buffer.Canvas.LineTo(ax-marg,ay);
    DrawFrame;
   end;  }

   WM_LBUTTONUP: DrawTrig:=false;

   WM_PAINT: begin
    BeginPaint(wnd,ps);
    DrawFrame;
    bitblt(getdc(MainWND),marg,0,buffer.Width,buffer.Height,buffer.Canvas.Handle,0,0,SRCCOPY);
    Endpaint(wnd,ps);
    result:=0;
   end;

   WM_GETMINMAXINFO:begin
    PMinMaxInfo(lparam)^.ptMinTrackSize:=point(350, 250);
    result:=0;
   end;
  else
   Result:=DefWindowProc(Wnd, Msg, wParam, lParam);
  end;
end;

BEGIN
 Buffer:=TBitmap.Create;
 Buffer.PixelFormat:=pf24bit;
 hFontBold:=CreateFont(8,0,0,0,0,0,0,0,DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,
            CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,0,'MS Sans Serif');

 WC.lpfnWndProc:=@WindowProc;
 WC.hicon:=loadicon(hinstance,'MAINICON');
 WC.hCursor:=LoadCursor(0,idc_arrow);
 WC.hbrBackground:=COLOR_BTNFACE+1;
 WC.lpszClassName:='MyWKlass';
 RegisterClass(WC);

 randomize;
 r1.Left:=0;
 r1.Top:=0;
 r1.Right:=wid-1;
 r1.Bottom:=wid-1;
 for ind:=1 to high(pole) do begin
  pole[ind].pic:=tbitmap.Create;
  pole[ind].pic.PixelFormat:=pf24bit;
  pole[ind].pic.Width:=wid;
  pole[ind].pic.Height:=wid;
  pole[ind].pic.Canvas.Brush.Color:=clyellow; //  
  pole[ind].pic.Canvas.FillRect(r1);
  pole[ind].pic.Canvas.Pen.Color:=clred;
  pole[ind].pic.Canvas.MoveTo(0,0);    //  
  pole[ind].pic.Canvas.LineTo(wid-1,0);
  pole[ind].pic.Canvas.LineTo(wid-1,wid-1);
  pole[ind].pic.Canvas.LineTo(0,wid-1);
  pole[ind].pic.Canvas.LineTo(0,0);
  pole[ind].pic.Canvas.Font.Size:=14;
  pole[ind].pic.Canvas.Font.Style:=[fsbold];
  pole[ind].pic.Canvas.TextOut(14,8,inttostr(ind));
  
  pole[ind].dx:=(0.5-random)/3;
  pole[ind].dy:=(0.5-random)/3;
 end;

 r1.Left:=100;    //    
 r1.Top:=100;
 r1.Right:=r1.Left+wid*3+1; //      - 1 
 r1.Bottom:=r1.Top+wid*2+1;

 Createpole;
{  pole[1].x:=r1.Left;
 pole[1].y:=r1.Top;

 pole[2].x:=pole[1].x+wid;
 pole[2].y:=r1.Top;

 pole[3].x:=pole[2].x+wid;
 pole[3].y:=r1.Top;

 pole[4].x:=r1.Left;
 pole[4].y:=r1.Top+wid;

 pole[5].x:=pole[4].x+wid;
 pole[5].y:=r1.Top+wid;   }

 MainWND:=CreateWindow('MyWKlass',' Conjunct Taken',
       WS_VISIBLE or WS_SYSMENU or WS_MINIMIZEBOX {or
       WS_MAXIMIZEBOX {or WS_THICKFRAME},
       (GetSystemMetrics(SM_CXSCREEN)-450) div 2,
       (GetSystemMetrics(SM_CYSCREEN)-350) div 2,
       450,350,0,0,hInstance, nil);
 postmessage(mainwnd,wm_size,0,0);

 activ:=true;
 trig:=false;
 CreateThread(nil,0,@CalcProc,nil,0,Thr);

 While GetMessage(Mesg,0,0,0) do begin
  TranslateMessage(Mesg);
  DispatchMessage(Mesg);
 end;
END.
